#include "delay.h"
#include "stdlib.h"
#include "i2s.h"
#include "CS43L22.h"
#include "i2c.h"
#include "stdio.h"
#include "math.h"


#define F_SAMPLE	96000.0f
#define F_OUT		2000.0f
#define PI 			3.14159f


uint16_t dataI2S[100];
float mySinVal;
float sample_dt;
uint16_t sample_N;
uint16_t i_t;




int main(void)
{
	delay_init(168000000);

	i2c_init();

	I2S3_Pins_Init();
	I2S3_Init();


	CS43L22_Pin_RST_Init();
	CS43_Init(MODE_I2S);
	CS43_SetVolume(100);
	CS43_Enable_RightLeft(CS43_RIGHT_LEFT);
	CS43_Start();

	sample_dt = F_OUT/F_SAMPLE;
	sample_N = F_SAMPLE/F_OUT;

	for(uint16_t i=0; i<sample_N; i++)
	{
		mySinVal = sinf(i*2*PI*sample_dt);

		dataI2S[i*2] = (mySinVal )*8000;    //Right data (0 2 4 6 8 10 12)

		dataI2S[i*2 + 1] =(mySinVal )*8000; //Left data  (1 3 5 7 9 11 13)
	}

	I2S_SendData_DMA(dataI2S, 100);

	while(1)
	{


	}


}


